package wusthelper.web.api.v2.dto.response;

import cn.wustlinghang.mywust.data.global.Course;
import lombok.Data;

@Data
public class CourseResponse {
    /**
     * 课程名称
     */
    private String className;
    /**
     * 教学班
     */
    private String teachClass;
    /**
     * 教师
     */
    private String teacher;
    /**
     * 开始周次
     */
    private Integer startWeek;
    /**
     * 结束周
     */
    private Integer endWeek;
    /**
     * 节数
     */
    private Integer section;
    /**
     * 星期
     */
    private Integer weekDay;
    /**
     * 教室
     */
    private String classroom;

    public static CourseResponse from(Course course) {
        CourseResponse courseResponse = new CourseResponse();
        courseResponse.setClassName(course.getName());
        courseResponse.setTeachClass(course.getTeachClass());
        courseResponse.setTeacher(course.getTeacher());
        courseResponse.setStartWeek(course.getStartWeek());
        courseResponse.setEndWeek(course.getEndWeek());
        courseResponse.setSection((course.getStartSection() + 1) / 2);
        courseResponse.setWeekDay(course.getWeekDay());
        courseResponse.setClassroom(course.getClassroom().getRoom());

        return courseResponse;

    }
}
