package wusthelper.web.rpc.undergrad;

import org.springframework.stereotype.Component;
import wusthelper.internal.rpc.response.RpcResponseDto;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

@Component
@FeignClient(name = "wusthelper.undergrad", contextId = "undergrad-trainingPlan")
public interface TrainingPlanRemote {
    String ROOT_PATH = "/training_plan";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<String> get(@RequestParam("cookie") String cookie);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<String> parse(String html);
}
