package wusthelper.web.rpc.undergrad;

import cn.wustlinghang.mywust.data.global.StudentInfo;
import org.springframework.stereotype.Component;
import wusthelper.internal.rpc.response.RpcResponseDto;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

@Component
@FeignClient(name = "wusthelper.undergrad", contextId = "undergrad-studentInfo")
public interface UndergradStudentInfoRemote {
    String ROOT_PATH = "/student_info";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<StudentInfo> get(@RequestParam("cookie") String cookie);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<StudentInfo> parse(String html);
}
