package wusthelper.web.service.campus.undergrad;

import wusthelper.code.ServiceCode;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.undergrad.CourseTableRemote;
import wusthelper.web.service.cookie.CookieManager;
import cn.wustlinghang.mywust.data.global.Course;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class UndergradCourseTableService {
    private final CourseTableRemote courseTableRemote;

    private final CookieManager cookieManager;

    public UndergradCourseTableService(CourseTableRemote courseTableRemote, CookieManager cookieManager) {
        this.courseTableRemote = courseTableRemote;
        this.cookieManager = cookieManager;
    }

    public List<Course> getCourseTable(String user, String term) {
        String cookie = cookieManager.getCookie(user, CookieType.Undergrad);
        var rpcResp = courseTableRemote.get(cookie, term);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.error(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
