package wusthelper.web.util;

public class StringUtil {

    public static boolean isPositiveNumber(final String str) {
        if (str == null || "".equals(str)) {
            return false;
        }

        int length = str.length();
        for (int i = 0; i < length; i++) {
            int ch = str.charAt(i);
            // 判断字符0-9，还有.
            // 负数不考虑
            if ((ch < 48 || ch > 57 ) && ch != 46) {
                return false;
            }
        }

        return true;
    }

    /**
     * 成绩换算成学分
     *
     * @param gradeString 数字成绩字符串
     * @return 换算后的学分
     */
    public static float numberGradeToGradePoint(String gradeString) {
        float gradeFloat = Float.parseFloat(gradeString);
        if (gradeFloat >= 90.0F) {
            return 4.0F;
        } else if (gradeFloat >= 85.0F) {
            return 3.7F;
        } else if (gradeFloat >= 82.0F) {
            return 3.3F;
        } else if (gradeFloat >= 78.0F) {
            return 3.0F;
        } else if (gradeFloat >= 75.0F) {
            return 2.7F;
        } else if (gradeFloat >= 72.0F) {
            return 2.3F;
        } else if (gradeFloat >= 68.0F) {
            return 2.0F;
        } else if (gradeFloat >= 64.0F) {
            return 1.5F;
        } else if (gradeFloat >= 60.0F) {
            return 1.0F;
        } else {
            return 0.0F;
        }
    }

    /**
     * 等级成绩换算成学分
     *
     * @param gradeLevel 成绩等级
     * @return 换算后的学分
     */
    public static float levelGradeToGradePoint(String gradeLevel) {
        switch (gradeLevel) {
            case "A":
                return 4.0F;
            case "A-":
                return 3.7F;
            case "B+":
                return 3.3F;
            case "B":
                return 3.0F;
            case "B-":
                return 2.7F;
            case "C+":
                return 2.3F;
            case "C":
                return 2.0F;
            case "C-":
                return 1.5F;
            case "D":
                return 1.0F;
            case "F":
                return 0.0F;
            default:
                return 0.0F;
        }
    }
}
