package wusthelper.internal.rpc.exception;

import wusthelper.code.ServiceCode;

public class RpcException extends RuntimeException {
    protected final int code;

    public RpcException(int code, String message) {
        super(message);
        this.code = code;
    }

    public RpcException(int code) {
        this(code, ServiceCode.getDescribe(code));
    }

    public int getCode() {
        return code;
    }

    public static RpcException ApiNotImplement() {
        return new RpcException(-1, null);
    }

    public static void error(int code) {
        throw new RpcException(code);
    }
}
