package wusthelper.internal.rpc.response;

import com.fasterxml.jackson.annotation.JsonInclude;
import wusthelper.code.ServiceCode;

@JsonInclude(JsonInclude.Include.NON_NULL)
public record RpcResponseDto<T>(int code, T data) {
    public static <T> RpcResponseDto<T> success(T data) {
        return new RpcResponseDto<>(ServiceCode.Ok, data);
    }

    public static <T> RpcResponseDto<T> success() {
        return success(null);
    }

    public static <T> RpcResponseDto<T> error(int code) {
        return new RpcResponseDto<>(code, null);
    }
}