package wusthelper.internal.graduate.services;

import cn.wustlinghang.mywust.exception.ApiException;
import lombok.extern.slf4j.Slf4j;
import wusthelper.code.ServiceCode;
import wusthelper.internal.rpc.exception.RpcException;

@Slf4j
public abstract class BaseService {
    protected RpcException wrapApiException(ApiException e) {
        return switch (e.getCode()) {
            case NETWORK_EXCEPTION -> new RpcException(ServiceCode.NetworkError);
            case COOKIE_INVALID -> new RpcException(ServiceCode.CookieInvalid);
            default -> {
                log.error("研究生：代理请求异常，异常未处理");
                log.error("异常：", e);
                yield new RpcException(ServiceCode.Unknown);
            }
        };
    }
}
