package wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.BookDetailApiService;
import cn.wustlinghang.mywust.data.library.parsed.BookDetail;
import cn.wustlinghang.mywust.exception.ApiException;
import jakarta.enterprise.context.ApplicationScoped;
import wusthelper.code.ServiceCode;
import wusthelper.internal.rpc.exception.RpcException;

import java.io.IOException;

@ApplicationScoped
public class BookDetailService extends BaseService {
    private final BookDetailApiService api;

    public BookDetailService(BookDetailApiService api) {
        this.api = api;
    }

    public BookDetail getBookDetail(String bookId) throws RpcException {
        try {
            return api.getBookDetail(bookId);
        } catch (ApiException e) {
            throw wrapApiException(e);
        } catch (IOException e) {
            throw new RpcException(ServiceCode.NetworkError);
        }
    }

}
