package wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.BookHoldingApiService;
import cn.wustlinghang.mywust.data.library.parsed.BookHolding;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import wusthelper.code.ServiceCode;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;
import java.util.List;

@ApplicationScoped
public class BookHoldingService extends BaseService {
    private final BookHoldingApiService api;

    public BookHoldingService(BookHoldingApiService api) {
        this.api = api;
    }

    public List<BookHolding> getHoldings(String id)
            throws RpcException {
        try {
            return api.getHoldingList(id);
        } catch (ApiException e) {
            throw wrapApiException(e);
        } catch (IOException e) {
            throw new RpcException(ServiceCode.NetworkError);
        } catch (ParseException e) {
            throw new RpcException(ServiceCode.ParseError);
        }
    }
}
