package wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.CurrentLoanApiService;
import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.CurrentLoanBook;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import jakarta.enterprise.context.ApplicationScoped;
import wusthelper.code.ServiceCode;
import wusthelper.internal.rpc.exception.RpcException;

import java.io.IOException;
import java.util.List;

@ApplicationScoped
public class CurrentLoanService extends BaseService {
    private final CurrentLoanApiService api;

    public CurrentLoanService(CurrentLoanApiService api) {
        this.api = api;
    }

    public PagingResult<List<CurrentLoanBook>> getCurrentLoan(String cookie, int page, int pageSize)
            throws RpcException {
        try {
            return api.getCurrentLoan(cookie, page, pageSize);
        } catch (ApiException e) {
            throw wrapApiException(e);
        } catch (IOException e) {
            throw new RpcException(ServiceCode.NetworkError);
        } catch (ParseException e) {
            throw new RpcException(ServiceCode.ParseError);
        }
    }
}
