package wusthelper.internal.physics.api.http.v1.handler;

import jakarta.enterprise.context.ApplicationScoped;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;
import lombok.extern.slf4j.Slf4j;
import wusthelper.code.ServiceCode;

import java.io.IOException;

@Slf4j
@Provider
@ApplicationScoped
public class IOExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<IOException> {
    @Override
    public Response toResponse(IOException e) {
        log.error("IO异常：", e);
        return super.toResponse(ServiceCode.NetworkError, "IOExceptionHandler");
    }
}
