package wusthelper.internal.undergrad.services;

import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradExamDelayApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import lombok.extern.slf4j.Slf4j;
import wusthelper.code.ServiceCode;
import wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@Slf4j
@ApplicationScoped
public class ExamActivitiesService extends BaseService {
    private final UndergradExamDelayApiService examDelayApiService;

    public ExamActivitiesService(UndergradExamDelayApiService examDelayApiService) {
        this.examDelayApiService = examDelayApiService;
    }

    public UndergradExamDelayApiService.ExamActivity[] getExamActivities(String cookie, String term)
            throws RpcException {
        try {
            return examDelayApiService.getActivities(term, cookie);
        } catch (ApiException e) {
            throw wrapApiException(e);
        } catch (IOException e) {
            log.error("解析错误：", e);
            throw new RpcException(ServiceCode.NetworkError);
        }
    }

}
